/*
	$Id: SqlAbstractColumn.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlAbstractColumn_h__
#define __SqlAbstractColumn_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlElement.h>
#include <librfcdal/SqlTable.h>

namespace RfcDal
{
	class SqlValue;

	class RFCDAL_EXPORT SqlAbstractColumn : public SqlElement
	{
		private:
			SqlTable _table;

		public:
			SqlAbstractColumn( const SqlTable& table );
			SqlAbstractColumn( const SqlAbstractColumn& column );
			virtual ~SqlAbstractColumn();

			const SqlAbstractColumn& operator=( const SqlAbstractColumn& column );

			virtual std::string id() const = 0;

			virtual std::string toSql( const SqlLanguage& language, const SqlAliasSet& aliasS = SqlAliasSet(), Context context = ctxDefault ) const = 0;

			const SqlTable& table() const;

		protected:
			void table( const SqlTable& table );

		private:
			SqlAbstractColumn();
	};
};

#endif /* !__SqlAbstractColumn_h__ */
