/*
	$Id: SqlBinary.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2009, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlBinary_h__
#define __SqlBinary_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlValue.h>

#include <string>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlBinary : public SqlValue
	{
		private:
			size_t _nLength;
			unsigned char* _pbyData;

		public:
			SqlBinary();
			SqlBinary( const SqlBinary& binary, const std::string& strAlias = std::string() );
			SqlBinary( const unsigned char* pbyData, size_t nLength, const std::string& strAlias = std::string() );
			virtual ~SqlBinary();

			const SqlBinary& operator=( const SqlBinary& binary );

			virtual std::string toSql( const SqlLanguage& language, const SqlAliasSet& aliasS = SqlAliasSet(), Context context = ctxDefault ) const;

			const unsigned char* data() const;
			size_t length() const;

			virtual SqlValue* copy() const;

			static SqlBinary fromText( const std::string& strText );
	};
};

#endif /* !__SqlBinary_h__ */
