/*
	$Id: SqlColumnInfo.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlColumnInfo_h__
#define __SqlColumnInfo_h__

#include <librfcdal/SqlGlobal.h>

#include <string>
#include <vector>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlColumnInfo
	{
		public:
			enum Bind { bindNull, bindString, bindInt, bindReal,
						bindDate, bindTime, bindDateTime, bindText, bindBlob,
						bindGS, bindGSPoint, bindGSLinestring, bindGSSimplePolygon, bindGSPolygon,
						bindGSMultiPoint, bindGSMultiLinestring, bindGSMultiPolygon };

		private:
			Bind _bind;
			std::string _strName;
			unsigned _nSize;
			bool _bIsPK;
			bool _bIsNullable;

		public:
			SqlColumnInfo();
			SqlColumnInfo( const SqlColumnInfo& info );
			SqlColumnInfo( Bind bind, const std::string& strName, unsigned nSize = 0, bool bIsPK = false, bool bIsNullable = false );
			virtual ~SqlColumnInfo();

			const SqlColumnInfo& operator=( const SqlColumnInfo& info );

			Bind bind() const;
			const std::string& name() const;
			unsigned size() const;
			bool isPK() const;
			bool isNullable() const;
	};

	class SqlQueryInfo : public std::vector<SqlColumnInfo>
	{
	};
};

#endif /* !__SqlColumnInfo_h__ */
