/*
	$Id: SqlCompoundCondition.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlCompoundCondition_h__
#define __SqlCompoundCondition_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlCondition.h>
#include <librfcdal/SqlConditionPtr.h>

#include <vector>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlCompoundCondition : public SqlCondition
	{
		public:
			enum Compound { compAnd, compOr };

		private:
			Compound _compound;
			SqlConditionPtrList _conditionS;

		public:
			SqlCompoundCondition();
			SqlCompoundCondition( Compound compound );
			SqlCompoundCondition( const SqlCompoundCondition& condition );
			virtual ~SqlCompoundCondition();

			const SqlCompoundCondition& operator=( const SqlCompoundCondition& condition );

			void addCondition( const SqlCondition& condition );
			void addCondition( const SqlCompoundCondition& condition );
			void addCondition( const SqlConditionPtr& condition );
			int count() const;

			virtual std::string toSql( const SqlLanguage& language, const SqlAliasSet& aliasS = SqlAliasSet(), Context context = ctxDefault ) const;
	};
};

#endif /* !__SqlCompoundCondition_h__ */
