/*
	$Id: SqlElement.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlElement_h__
#define __SqlElement_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlException.h>
#include <librfcdal/SqlErrors.h>
#include <librfcdal/SqlLanguage.h>
#include <librfcdal/SqlAlias.h>

#include <string>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlElement
	{
		public:
/// KILL 2.7
//			enum Output { outName, outAlias, outAll, outSuppressAlias, outUnquote };
			enum Context { ctxDefault,
							ctxSelectColumnDefault, ctxSelectColumnFull, ctxSelectColumnDefine, ctxSelectTableDefault,
							ctxSelectTableDefine, ctxSelectTableFull, ctxSelectConditionColumn, ctxSelectColumnUnquotedText, ctxSelectFunctionColumn,
							ctxModifyTable, ctxModifyConditionColumn, ctxModifyColumn,
							ctxConditionSelect, ctxConditionModify, ctxJoinConditionColumn, ctxConditionJoin
						};

			enum Distinct{ selectAll, selectDistinct };

		public:
			SqlElement();
			virtual ~SqlElement();

			virtual std::string toSql( const SqlLanguage& language, const SqlAliasSet& aliasS = SqlAliasSet(), Context context = ctxDefault ) const = 0;

			static std::string context( Context in );
	};
};
 
#endif /* !__SqlElement_h__ */
