/*
	$Id: SqlErrors.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlErrors_h__
#define __SqlErrors_h__

namespace RfcDal
{
	const int SQLERR_OK								= 0;

// Database & table errors
	const int SQLERR_MISSINGSCHEMA					= 1001;
	const int SQLERR_CIRCUMSTANTIALMISSINGSCHEMA	= 1002;
	const int SQLERR_MISSINGDATABASE				= 1003;

// Condition Errors
	const int SQLERR_NOCONDITION					= 1101;
	const int SQLERR_CONDITIONREQUIRESSRHS			= 1102;

// Column Errors
	const int SQLERR_TEXTHASNOVALUE					= 1201;
	const int SQLERR_FUNCTIONHASNOVALUE				= 1202;
	const int SQLERR_EXPRESSIONHASNOVALUE			= 1203;
	const int SQLERR_COLUMNHASNULLVALUE				= 1204;
	const int SQLERR_COLUMNHASINVALIDVALUE			= 1205;
	const int SQLERR_EXPRESSIONNEEDSALIAS			= 1206;

// Value Errors
	const int SQLERR_BADDATEFORMAT					= 1301;
	const int SQLERR_BADDATEVALUE					= 1302;
	const int SQLERR_BADTIMEFORMAT					= 1303;
	const int SQLERR_BADTIMEVALUE					= 1304;
	const int SQLERR_BADTIMESTAMPFORMAT				= 1305;
	const int SQLERR_TOOMANYDECIMALS				= 1310;
// #define SQLERR_BADTIMESTAMPVALUE		not used. will either throw a BADDATEVALUE or a BADTIMEVALUE

// toSql  Errors
	const int SQLERR_BADCONTEXT						= 1350;

// Geo-spatial Value Errors
	const int SQLERR_INCORRECTGSTYPE				= 1401;
	const int SQLERR_INAPPROPRIATEFORGSTYPE			= 1402;
	const int SQLERR_WRONGGSTYPE					= 1403;
	const int SQLERR_MALFORMEDGSDATA				= 1404;

// Select Statement Errors

// Modify Statement Errors
	const int SQLERR_MODIFYREQUIRESSTATEMENT		= 2101;

// Insert Statement Errors
	const int SQLERR_ITEXTNOTVALIDTARGET			= 2201;
	const int SQLERR_IFUNCTIONNOTVALIDTARGET		= 2202;

// Update Statement Errors
	const int SQLERR_UTEXTNOTVALIDTARGET			= 2301;
	const int SQLERR_UFUNCTIONNOTVALIDTARGET		= 2302;

// Delete Statement Errors

// Query Errors
	const int SQLERR_NOSUCHCOLUMN					= 6001;

// Miscellaneous Errors
	const int SQLERR_INVALIDDELIMITER				= 8001;
};


#endif /* !__SqlErrors_h__ */
