/*
	$Id: SqlException.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlException_h__
#define __SqlException_h__

#include <librfcdal/SqlGlobal.h>

#include <string>
#include <ostream>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlException
	{
		private:
			std::string _strFile;
			int _nLine;
			int _nErrorCode;
			std::string _strLegend;

		public:
			SqlException( const std::string& strFile, int nLine, int nErrorCode, const std::string& strLegend = std::string() );
			virtual ~SqlException();

			const std::string& file() const;
			int line() const;
			int errorCode() const;
			const std::string& legend() const;

			static std::string explainErrorCode( int nErrorCode );
	};
};

RFCDAL_EXPORT std::ostream& operator<<( std::ostream& stream, const RfcDal::SqlException& e );

#endif /* !__SqlException_h__ */
