/*
	$Id: SqlExpression.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlExpression_h__
#define __SqlExpression_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlAbstractColumn.h>
#include <librfcdal/SqlColumnPtr.h>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlExpression : public SqlAbstractColumn
	{
		public:
			enum Expression { expPlus, expMinus, expMultiply, expDivide, expAnd, expOr };

		private:
			SqlColumnPtr _columnLHS;
			SqlColumnPtr _columnRHS;
			Expression _expression;
			std::string _strAlias;

		public:
			SqlExpression( const SqlExpression& expression );
			SqlExpression( const SqlColumnPtr& columnLHS, const SqlColumnPtr& columnRHS, Expression expression, const std::string& strAlias = std::string() );
			virtual ~SqlExpression();

			virtual std::string id() const;

			virtual std::string toSql( const SqlLanguage& language, const SqlAliasSet& aliasS = SqlAliasSet(), Context context = ctxDefault ) const;

			const SqlExpression& operator=( const SqlExpression& expression );
	};
};

#endif /* !__SqlExpression_h__ */
