/*
	$Id: SqlFunction.h 1246 2018-12-10 19:54:00Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlFunction_h__
#define __SqlFunction_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlAbstractColumn.h>
#include <librfcdal/SqlColumnarElement.h>
#include <librfcdal/SqlColumnPtr.h>

#include <string>
#include <vector>

namespace RfcDal
{
	class SqlColumn;

	class RFCDAL_EXPORT SqlFunction : public SqlAbstractColumn, public SqlColumnarElement
	{
		private:
			std::string _strFunction;
			std::string _strAlias;

		public:
			SqlFunction();
			SqlFunction( const SqlFunction& function );
			SqlFunction( const std::string& strFunction, const std::string& strAlias = std::string() );
			virtual ~SqlFunction();

			const SqlFunction& operator=( const SqlFunction& function );

			virtual std::string id() const;

			virtual std::string toSql( const SqlLanguage& language, const SqlAliasSet& aliasS = SqlAliasSet(), Context context = ctxDefault ) const;
	};
};

#endif /* !__SqlFunction_h__ */
