/*
	$Id: SqlGSLinestring.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlGSLinestring_h__
#define __SqlGSLinestring_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlGSPoint.h>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlGSLinestring : public SqlGeospatialValue
	{
		private:
			SqlGSPointList _pointS;

		public:
			SqlGSLinestring( const std::string& strAlias = std::string() );
			SqlGSLinestring( const SqlGSLinestring& line );
			virtual ~SqlGSLinestring();

			const SqlGSLinestring& operator=( const SqlGSLinestring& line );

			void addPoint( const SqlGSPoint& point );
			const SqlGSPointList& points() const;

			virtual std::string id() const;
			virtual GeospatialType type() const;

			virtual std::string toWkt( Suppression suppression ) const;

			virtual SqlValue* copy() const;

			static SqlGSLinestring fromText( const std::string& strText );

		protected:
			static SqlGSLinestring fromText( const std::string& strText, bool bSubMulti );

			friend class SqlGSMultiLinestring;
	};

	class SqlGSLinestringList : public std::vector<SqlGSLinestring>
	{
	};
};

#endif /* !__SqlGSLinestring_h__ */
