/*
	$Id: SqlGSMultiLinestring.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlGSMultiLinestring_h__
#define __SqlGSMultiLinestring_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlGSLinestring.h>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlGSMultiLinestring : public SqlGeospatialValue
	{
		private:
			SqlGSLinestringList _lineS;

		public:
			SqlGSMultiLinestring( const std::string& strAlias = std::string() );
			SqlGSMultiLinestring( const SqlGSMultiLinestring& line );
			virtual ~SqlGSMultiLinestring();

			const SqlGSMultiLinestring& operator=( const SqlGSMultiLinestring& line );

			void addLinestring( const SqlGSLinestring& line );
			const SqlGSLinestringList& lines() const;

			virtual std::string id() const;
			virtual GeospatialType type() const;

			virtual std::string toWkt( Suppression suppression ) const;

			virtual SqlValue* copy() const;

			static SqlGSMultiLinestring fromText( const std::string& strText );
	};
};

#endif /* !__SqlGSMultiLinestring_h__ */
