/*
	$Id: SqlGSMultiPoint.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlGSMultiPoint_h__
#define __SqlGSMultiPoint_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlGSPoint.h>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlGSMultiPoint : public SqlGeospatialValue
	{
		private:
			SqlGSPointList _pointS;

		public:
			SqlGSMultiPoint( const std::string& strAlias = std::string() );
			SqlGSMultiPoint( const SqlGSMultiPoint& point );
			virtual ~SqlGSMultiPoint();

			const SqlGSMultiPoint& operator=( const SqlGSMultiPoint& point );

			void addPoint( const SqlGSPoint& point );
			const SqlGSPointList& points() const;

			virtual std::string id() const;
			virtual GeospatialType type() const;

			virtual std::string toWkt( Suppression suppression ) const;

			virtual SqlValue* copy() const;

			/*
			fromText
			creates a point list from text of the form:
				((x0 y0),(x1 y1),...,(xn yn))
			see also SqlGSPointList RfcDal::pointListFromText
			*/
			static SqlGSMultiPoint fromText( const std::string& strText );
	};
};

#endif /* !__SqlGSMultiPoint_h__ */
