/*
	$Id: SqlGSMultiPolygon.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlGSMultiPolygon_h__
#define __SqlGSMultiPolygon_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlGSPolygon.h>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlGSMultiPolygon : public SqlGeospatialValue
	{
		private:
			SqlGSPolygonList _polygonS;

		public:
			SqlGSMultiPolygon( const std::string& strAlias = std::string() );
			SqlGSMultiPolygon( const SqlGSMultiPolygon& poly );
			virtual ~SqlGSMultiPolygon();

			const SqlGSMultiPolygon& operator=( const SqlGSMultiPolygon& poly );

			void addPolygon( const SqlGSPolygon& poly );
			const SqlGSPolygonList& polygons() const;

			virtual std::string id() const;
			virtual GeospatialType type() const;

			virtual std::string toWkt( Suppression suppression ) const;

			virtual SqlValue* copy() const;

			static SqlGSMultiPolygon fromText( const std::string& strText );
	};
};

#endif /* !__SqlGSMultiPolygon_h__ */
