/*
	$Id: SqlGSSimplePolygon.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlGSSimplePolygon_h__
#define __SqlGSSimplePolygon_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlGSPoint.h>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlGSSimplePolygon : public SqlGeospatialValue
	{
		private:
			SqlGSPointList _pointS;

		public:
			SqlGSSimplePolygon( const std::string& strAlias = std::string() );
			SqlGSSimplePolygon( const SqlGSSimplePolygon& poly );
			virtual ~SqlGSSimplePolygon();

			const SqlGSSimplePolygon& operator=( const SqlGSSimplePolygon& poly );

			void addPoint( const SqlGSPoint& point );
			const SqlGSPointList& points() const;

			virtual std::string id() const;
			virtual GeospatialType type() const;

			virtual std::string toWkt( Suppression suppression ) const;

			virtual void setValue( const SqlValue& value );
			virtual const SqlValue& value() const;

			virtual SqlValue* copy() const;

			static SqlGSSimplePolygon fromText( const std::string& strText );
	};

	class SqlGSSimplePolygonList : public std::vector<SqlGSSimplePolygon>
	{
	};
};

#endif /* !__SqlGSSimplePolygon_h__ */
