/*
	$Id: SqlGlobal.h 1242 2018-12-03 16:15:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlGlobal_h__
#define __SqlGlobal_h__

#if defined (RFCDAL_EXPORT)
#	undef RFCDAL_EXPORT
#endif /* RFCDAL_EXPORT */

#if defined (LINUX)
#	define RFCDAL_EXPORT
#elif defined (_WINDOWS)
#	include <windows.h>
#	if defined (LIBRFCDAL_EXPORTS)
#		define RFCDAL_EXPORT __declspec( dllexport )
#	else
#		define RFCDAL_EXPORT __declspec( dllimport )
#	endif /* LIBRFCDAL_EXPORTS */
#	pragma warning( disable : 4101 4251 4275 4290 4584 4996 )
#endif /* LINUX */

#include <string>

namespace Base4c
{
	class Version;
}

namespace RfcDal
{
	RFCDAL_EXPORT const std::string& product();
	RFCDAL_EXPORT const Base4c::Version& version();
	RFCDAL_EXPORT const std::string& copyright();
}

#endif /* !__SqlGlobal_h__ */
