/*
	$Id: SqlInteger.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2009, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlInteger_h__
#define __SqlInteger_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlValue.h>

#include <string>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlInteger : public SqlValue
	{
		private:
			int _nValue;

		public:
			SqlInteger( const SqlInteger& integer, const std::string& strAlias = std::string() );
			SqlInteger( int nValue, const std::string& strAlias = std::string() );
			virtual ~SqlInteger();

			const SqlInteger& operator=( const SqlInteger& integer );

			virtual std::string toSql( const SqlLanguage& language, const SqlAliasSet& aliasS = SqlAliasSet(), Context context = ctxDefault ) const;

			int value() const;

			virtual SqlValue* copy() const;

			static SqlInteger fromText( const std::string& strText );
	};
};

#endif /* !__SqlInteger_h__ */
