/*
	$Id: SqlLoggerSyslog.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2011, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlLoggerSyslog_h__
#define __SqlLoggerSyslog_h__

#include <librfcdal/SqlLogger.h>

#include <string>
#include <vector>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlLoggerSyslog : public SqlLogger
	{
		private:
			std::string _strSource;
			int _nLog;

		public:
			SqlLoggerSyslog( const std::string& strSource, int nLog = 0 );
			virtual ~SqlLoggerSyslog();

		protected:
			virtual void logExceptionReal( const std::string& strLegend ) const;
			virtual void logWarningReal( const std::string& strLegend ) const;
			virtual void logDebugReal( const std::string& strLegend ) const;
	};
};

#endif /* !__SqlLoggerSyslog_h__ */
