/*
	$Id: SqlMapper.h 1186 2018-11-15 15:12:44Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlMapper_h__
#define __SqlMapper_h__

#include <librfcdal/SqlGlobal.h>

#include <string>
#include <vector>
#include <map>
#include <iostream>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlMapper
	{
		public:
			class RFCDAL_EXPORT FieldMap : public std::map<std::string, int>
			{
				public:
					FieldMap();
					FieldMap( const FieldMap& fieldS );
					FieldMap( const std::vector<std::string>& fieldS );
			};

			class RFCDAL_EXPORT ColumnMap : public std::map<std::string, std::string>
			{
				public:
					ColumnMap();
					ColumnMap( const ColumnMap& columnS );
			};
	};
}

#endif /* !__SqlMapper_h__ */
