/*
	$Id: SqlQueryStatement.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlQueryStatement_h__
#define __SqlQueryStatement_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlStatement.h>
#include <librfcdal/SqlColumn.h>

namespace RfcDal
{
	class SqlAbstractColumn;

	class RFCDAL_EXPORT SqlQueryStatement : public SqlStatement
	{
		private:
			SqlColumn _column;
			std::string _strQuery;

		public:
			SqlQueryStatement( const std::string& strQuery );
			SqlQueryStatement( const SqlQueryStatement& stmt );
			virtual ~SqlQueryStatement();

			const SqlQueryStatement& operator=( const SqlQueryStatement& stmt );

			virtual std::string toSql( const SqlLanguage& language, const SqlAliasSet& aliasS = SqlAliasSet(), Context context = ctxDefault ) const;

			virtual const SqlAbstractColumn& column( unsigned uIndex ) const;

		protected:
			SqlQueryStatement();
	};
};

#endif /* !__SqlSelectStatement_h__ */
