/*
	$Id: SqlUnion.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlUnion_h__
#define __SqlUnion_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlQueryStatement.h>
#include <librfcdal/SqlOrder.h>
#include <librfcdal/SqlLimit.h>

#include <vector>

namespace RfcDal
{
	class SqlOrder;
	class SqlSelectStatement;

	class RFCDAL_EXPORT SqlUnion : public SqlQueryStatement
	{
		private:
			std::vector<SqlSelectStatement> _statementS;
			SqlOrderList _orderS;
			SqlLimit _limit;

		public:
			SqlUnion();
			virtual ~SqlUnion();

			virtual std::string toSql( const SqlLanguage& language, const SqlAliasSet& aliasS = SqlAliasSet(), Context context = ctxDefault ) const;
			virtual const SqlAbstractColumn& column( unsigned uIndex ) const;

			void addStatement( const SqlSelectStatement& stmt );
			void addOrder( const SqlOrder& column );
			void setLimit( const SqlLimit& limit );
	};
};

#endif /* !__SqlUnion_h__ */
