/*
	$Id: SqlUpdateStatement.h 1177 2018-11-14 16:17:27Z john $

	This file is part of the RFC DAL.

	The RFC DAL is Copyright (c) 2004 - 2007, The 4c Company.

	The RFC DAL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 2 of the License.

	The RFC DAL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with This code.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SqlUpdateStatement_h__
#define __SqlUpdateStatement_h__

#include <librfcdal/SqlGlobal.h>
#include <librfcdal/SqlModifyStatement.h>
#include <librfcdal/SqlColumnarStatement.h>
#include <librfcdal/SqlColumnPtr.h>
#include <librfcdal/SqlConditionPtr.h>

#include <vector>

namespace RfcDal
{
	class RFCDAL_EXPORT SqlUpdateStatement : public SqlModifyStatement, public SqlColumnarStatement
	{
		private:
			SqlConditionPtr _condition;

		public:
			SqlUpdateStatement( const SqlTable& table );
			SqlUpdateStatement( const SqlUpdateStatement& stmt );
			virtual ~SqlUpdateStatement();

			const SqlUpdateStatement& operator=( const SqlUpdateStatement& stmt );

			void setWhere( const SqlConditionPtr& condition );

			virtual std::string toSql( const SqlLanguage& language, const SqlAliasSet& aliasS = SqlAliasSet(), Context context = ctxDefault ) const;

		private:
			SqlUpdateStatement();
	};
};

#endif /* !__SqlUpdateStatement_h__ */
